/*
 File: err_symbols_ph_th.h
 Date and Time: Fri Jan 30 18:55:10 2015 
*/
#ifndef __err_symbols_ph_th_h__
#define __err_symbols_ph_th_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

using namespace NS_yacco2_terminals;
#include "lint_balls.h"
#include "identifier.h"
#include "term_def_ph.h"
#include "c_string.h"
 
extern yacco2::Thread_entry ITH_err_symbols_ph_th;

extern yacco2::State S1_Cerr_symbols_ph_th;
namespace NS_err_symbols_ph_th {
yacco2::THR _YACCO2_CALL_TYPE
TH_err_symbols_ph_th(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_err_symbols_ph_th(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[17];
};
class Cerr_symbols_ph_th: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rerror_symbols_phrase_ = 569//start_of_rule_list + 0
    ,rhs1_Rerror_symbols_phrase_ = 1
   ,R_Ropen_par_ = 570//start_of_rule_list + 2
    ,rhs1_Ropen_par_ = 2
    ,rhs2_Ropen_par_ = 3
   ,R_Rclose_par_ = 571//start_of_rule_list + 4
    ,rhs1_Rclose_par_ = 4
    ,rhs2_Rclose_par_ = 5
   ,R_Rparameters_ = 572//start_of_rule_list + 6
    ,rhs1_Rparameters_ = 6
   ,R_Rfilename_phrase_ = 573//start_of_rule_list + 8
    ,rhs1_Rfilename_phrase_ = 7
   ,R_Rfilename_ = 574//start_of_rule_list + 10
    ,rhs1_Rfilename_ = 8
    ,rhs2_Rfilename_ = 9
    ,rhs3_Rfilename_ = 10
   ,R_Rfilename_id_ = 575//start_of_rule_list + 12
    ,rhs1_Rfilename_id_ = 11
    ,rhs2_Rfilename_id_ = 12
    ,rhs3_Rfilename_id_ = 13
   ,R_Rnamespace_phrase_ = 576//start_of_rule_list + 14
    ,rhs1_Rnamespace_phrase_ = 14
    ,rhs2_Rnamespace_phrase_ = 15
   ,R_Rnamespace_ = 577//start_of_rule_list + 16
    ,rhs1_Rnamespace_ = 16
    ,rhs2_Rnamespace_ = 17
    ,rhs3_Rnamespace_ = 18
   ,R_Rnamespace_id_ = 578//start_of_rule_list + 18
    ,rhs1_Rnamespace_id_ = 19
    ,rhs2_Rnamespace_id_ = 20
    ,rhs3_Rnamespace_id_ = 21
   ,R_Rsym_defs_phrase_ = 579//start_of_rule_list + 20
    ,rhs1_Rsym_defs_phrase_ = 22
   ,R_Rsym_defs_ = 580//start_of_rule_list + 22
    ,rhs1_Rsym_defs_ = 23
    ,rhs2_Rsym_defs_ = 24
   ,R_Rsym_def_ = 581//start_of_rule_list + 24
    ,rhs1_Rsym_def_ = 25
    ,rhs2_Rsym_def_ = 26
    ,rhs3_Rsym_def_ = 27
    ,rhs4_Rsym_def_ = 28
    ,rhs5_Rsym_def_ = 29
    ,rhs6_Rsym_def_ = 30
   ,R_Rsym_def1_ = 582//start_of_rule_list + 26
    ,rhs1_Rsym_def1_ = 31
    ,rhs2_Rsym_def1_ = 32
    ,rhs3_Rsym_def1_ = 33
    ,rhs4_Rsym_def1_ = 34
    ,rhs5_Rsym_def1_ = 35
   ,R_Ropen_brace_ = 583//start_of_rule_list + 28
    ,rhs1_Ropen_brace_ = 36
    ,rhs2_Ropen_brace_ = 37
   ,R_Rclose_brace_ = 584//start_of_rule_list + 30
    ,rhs1_Rclose_brace_ = 38
    ,rhs2_Rclose_brace_ = 39
   ,R_Rlint_ = 585//start_of_rule_list + 32
    ,rhs1_Rlint_ = 40
    ,rhs2_Rlint_ = 41
  };
  //no of la sets = 9
  //no of states = 69
  Cerr_symbols_ph_th();
  ~Cerr_symbols_ph_th();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[42];
  
    public:
    T_error_symbols_phrase* error_symbols_phrase_;
  
 };
struct Rerror_symbols_phrase;
struct Ropen_par;
struct Rclose_par;
struct Rparameters;
struct Rfilename_phrase;
struct Rfilename;
struct Rfilename_id;
struct Rnamespace_phrase;
struct Rnamespace;
struct Rnamespace_id;
struct Rsym_defs_phrase;
struct Rsym_defs;
struct Rsym_def;
struct Rsym_def1;
struct Ropen_brace;
struct Rclose_brace;
struct Rlint;
struct Rerror_symbols_phrase:public yacco2::CAbs_lr1_sym {
  Rerror_symbols_phrase(yacco2::Parser* P);
  public:
  void sr1();
};

struct Ropen_par:public yacco2::CAbs_lr1_sym {
  Ropen_par(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rclose_par:public yacco2::CAbs_lr1_sym {
  Rclose_par(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rparameters:public yacco2::CAbs_lr1_sym {
  Rparameters(yacco2::Parser* P);
  public:
};

struct Rfilename_phrase:public yacco2::CAbs_lr1_sym {
  Rfilename_phrase(yacco2::Parser* P);
 
public:T_file_name* filename_;

  public:
};

struct Rfilename:public yacco2::CAbs_lr1_sym {
  Rfilename(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rfilename_id:public yacco2::CAbs_lr1_sym {
  Rfilename_id(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rnamespace_phrase:public yacco2::CAbs_lr1_sym {
  Rnamespace_phrase(yacco2::Parser* P);
  public:
  void sr2();
};

struct Rnamespace:public yacco2::CAbs_lr1_sym {
  Rnamespace(yacco2::Parser* P);
  public:
  void sr2();
  void sr3();
};

struct Rnamespace_id:public yacco2::CAbs_lr1_sym {
  Rnamespace_id(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

struct Rsym_defs_phrase:public yacco2::CAbs_lr1_sym {
  Rsym_defs_phrase(yacco2::Parser* P);
  public:
};

struct Rsym_defs:public yacco2::CAbs_lr1_sym {
  Rsym_defs(yacco2::Parser* P);
  public:
};

struct Rsym_def:public yacco2::CAbs_lr1_sym {
  Rsym_def(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
  void sr6();
};

struct Rsym_def1:public yacco2::CAbs_lr1_sym {
  Rsym_def1(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
  void sr4();
  void sr5();
};

struct Ropen_brace:public yacco2::CAbs_lr1_sym {
  Ropen_brace(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rclose_brace:public yacco2::CAbs_lr1_sym {
  Rclose_brace(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rlint:public yacco2::CAbs_lr1_sym {
  Rlint(yacco2::Parser* P);
  public:
};

} // end of namespace

#endif
